/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractTree;
import org.richfaces.component.SwitchType;

/**
 *  @author Nick Belaevski
 

 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UITree extends AbstractTree
        {

    public static final String COMPONENT_TYPE="org.richfaces.Tree";

    public static final String COMPONENT_FAMILY="org.richfaces.Tree";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UITree() {
        super();
        setRendererType("org.richfaces.TreeRenderer");
    }



    protected static enum Properties {
        immediate,
        nodeType,
        selectionType,
        styleClass,
        toggleType,
        value

    }


 
    public boolean isImmediate() {
        return Boolean.valueOf(getStateHelper().eval(Properties.immediate, false).toString());
    }
    
    public void setImmediate(boolean immediate) {
        getStateHelper().put(Properties.immediate, immediate);
    }

 
    public String getNodeType() {
        return (String) getStateHelper().eval(Properties.nodeType);
    }
    
    public void setNodeType(String nodeType) {
        getStateHelper().put(Properties.nodeType, nodeType);
    }

 
    public org.richfaces.component.SwitchType getSelectionType() {
        return (SwitchType) getStateHelper().eval(Properties.selectionType, SwitchType.client);
    }
    
    public void setSelectionType(org.richfaces.component.SwitchType selectionType) {
        getStateHelper().put(Properties.selectionType, selectionType);
    }

 
    public String getStyleClass() {
        return (String) getStateHelper().eval(Properties.styleClass);
    }
    
    public void setStyleClass(String styleClass) {
        getStateHelper().put(Properties.styleClass, styleClass);
    }

 
    public org.richfaces.component.SwitchType getToggleType() {
        return (SwitchType) getStateHelper().eval(Properties.toggleType, SwitchType.DEFAULT);
    }
    
    public void setToggleType(org.richfaces.component.SwitchType toggleType) {
        getStateHelper().put(Properties.toggleType, toggleType);
    }

 
    public Object getValue() {
        return (Object) getStateHelper().eval(Properties.value);
    }
    
    public void setValue(Object value) {
        getStateHelper().put(Properties.value, value);
    }

}